BaseGraphComponent Class Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Classes | Public Member Functions
BaseGraphComponent Class Reference

## Detailed Description

This class describes the base interface of undirected graph types. All graph concepts have to conform to this class. It extends the interface of BaseDigraphComponent with an `Edge` type and functions to get the end nodes of edges, to convert from arcs to edges and to get both direction of edges.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for BaseGraphComponent:
[legend]

## Classes
class | Edge
| Undirected edge class of the graph. More...

## Public Member Functions
Node | u (const Edge &) const
| Return one end node of an edge. More...
Node | v (const Edge &) const
| Return the other end node of an edge. More...
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge. More...
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge. More...
bool | direction (const Arc &) const
| Return the direction of the arc. More...
Arc | oppositeArc (const Arc &) const
| Return the opposite arc. More...
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc. More...
Node | target (const Arc &) const
| Return the target node of an arc. More...
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc. More...

## Additional Inherited Members
Public Types inherited from BaseDigraphComponent
typedef GraphItem<'n'> | Node
| Node class of the digraph. More...
typedef GraphItem<'a'> | Arc
| Arc class of the digraph. More...

## Member Function Documentation

Node u | ( | const Edge & |  | ) | const
| inline

This function returns one end node of an edge.

Node v | ( | const Edge & |  | ) | const
| inline

This function returns the other end node of an edge.

Arc direct | ( | const Edge & | ,
|  | bool |
| ) |  | const
| inline

This function returns a directed arc from its direction and the represented edge.

Arc direct | ( | const Edge & | ,
|  | const Node & |
| ) |  | const
| inline

This function returns a directed arc from its source node and the represented edge.

bool direction | ( | const Arc & |  | ) | const
| inline

Returns the direction of the arc. Each arc represents an edge with a direction. It gives back the direction.

Arc oppositeArc | ( | const Arc & |  | ) | const
| inline

This function returns the opposite arc, i.e. the arc representing the same edge and has opposite direction.